<?php
/****************************************************************************
* Project:       PHP Remote Studio Applet
* Invoking a Remote Task in Omnis Studio (Version > 4.1) with a PHP Script
*****************************************************************************
* File:          RSA_List.php
* First created: 2004-xx-xx
* Author:        NN
* Last modified: 2006-06-07
* Modified by:   Michael Hufschmidt
* Copyright (C): Raining Data 2004
*****************************************************************************
* Content / Description / Requirements / Usage:
*
* Definition of the class "RSA_List" which handles list objects
****************************************************************************/
class RSA_List {
  var $mRowCount;
  var $mColCount;
  var $mVars;

  function RSA_List($rCnt, $cCnt) {
    $this->mRowCount = $rCnt;
    $this->mColCount = $cCnt;
    for ($r = 0; $r <= $rCnt; $r ++) {
      for ($c = 0; $c <= $cCnt; $c ++) {
        $this->mVars[($r * $cCnt) + $c] = new RSA_Var();
      }
    }
  }

  function getElementIdx($pRow, $pCol) {
    if ($pRow > 0 && $pRow <= $this->mRowCount && $pCol > 0 && $pCol <= $this->mColCount) {
      $pRow --;
      $pCol --;
      return ($this->mColCount * $pRow) + $pCol;
    }
    return -1;
  }

  // Use with care as this will give you a copy of the list item	 	  
  function getElement($pRow, $pCol) {
    if ($pRow > 0 && $pRow <= $this->mRowCount && $pCol > 0 && $pCol <= $this->mColCount) {
      $pRow --;
      $pCol --;
      return $this->mVars[($this->mColCount * $pRow) + $pCol];
    }
    return NULL;
  }

  function colCount() {
    return $this->mColCount;
  }

  function rowCount() {
    return $this->mRowCount;
  }
}
?>

